ghc-7.0.4: The GHC API

Pretty

# Documentation

data Doc Source

Instances

Show Doc |

data Mode Source

Constructors

PageMode |
ZigZagMode |
LeftMode |
OneLineMode |

data TextDetails Source

Constructors

Chr !Char |
Str String |
PStr FastString |
LStr !LitString FastInt |

empty :: Doc Source

isEmpty :: Doc -> Bool Source

nest :: Int -> Doc -> Doc Source

char :: Char -> Doc Source

text :: String -> Doc Source

ftext :: FastString -> Doc Source

ptext :: LitString -> Doc Source

int :: Int -> Doc Source

integer :: Integer -> Doc Source

float :: Float -> Doc Source

double :: Double -> Doc Source

rational :: Rational -> Doc Source

parens :: Doc -> Doc Source

brackets :: Doc -> Doc Source

braces :: Doc -> Doc Source

quotes :: Doc -> Doc Source

doubleQuotes :: Doc -> Doc Source

semi :: Doc Source

comma :: Doc Source

colon :: Doc Source

space :: Doc Source

equals :: Doc Source

lparen :: Doc Source

rparen :: Doc Source

lbrack :: Doc Source

rbrack :: Doc Source

lbrace :: Doc Source

rbrace :: Doc Source

cparen :: Bool -> Doc -> Doc Source

(<>) :: Doc -> Doc -> Doc Source

(<+>) :: Doc -> Doc -> Doc Source

hcat :: [Doc] -> Doc Source

hsep :: [Doc] -> Doc Source

($$) :: Doc -> Doc -> Doc Source

($+$) :: Doc -> Doc -> Doc Source

vcat :: [Doc] -> Doc Source

sep :: [Doc] -> Doc Source

cat :: [Doc] -> Doc Source

fsep :: [Doc] -> Doc Source

fcat :: [Doc] -> Doc Source

hang :: Doc -> Int -> Doc -> Doc Source

punctuate :: Doc -> [Doc] -> [Doc]Source

render :: Doc -> String Source

fullRender :: Mode -> Int -> Float -> (TextDetails -> a -> a) -> a -> Doc -> aSource

printDoc :: Mode -> Handle -> Doc -> IO ()Source

showDocWith :: Mode -> Doc -> String Source

bufLeftRender :: BufHandle -> Doc -> IO ()Source